(function capsule(window) {
  function defineLibrary() {
    const AudioLib = {};
    AudioLib.done = false;
    const audio = document.createElement('audio');
    audio.crossOrigin = 'anonymous';
    AudioLib.audio = audio;
    AudioLib.setCallBack = function setCallback(audioReadyCallback) {
      AudioLib.audioDone = audioReadyCallback;
    };

    AudioLib.player = new CPlayer();
    AudioLib.startDemo = function startDemo() {
  //----------------------------------------------------------------------------
  // Music data section
  //----------------------------------------------------------------------------

  // Include current song data url here to allow easy access to edit it if needed
  //
  // http://sb.bitsnbites.eu/?data=U0JveAwC7d1NbxtFGMDxZ_bFqSBIVKpQL6gFFaVSheBY0SAOHNIDnOAAFKlCBSVElqKqURUR0aws15ZlyzhZRa24IHHlG8CBolxA3PgI8AH4CGFm12tvnV17rW6yY_qfeF48nsw8-7NzyWjWO6-IfCaXl50vAnHuBK46J3fF9-SoptwHl-X8P-e6S8pxvXSWVBr1pzuLttXSoOhQS8f1LY2raFhh0YGWjutZGtfzGtai_z0_r-8b140AAggggAACCCCAAAIIIIAAAggggAACCCBQroDzkt52u6m33USumpmPauJ0RF26W1urJStNbr899VyZ5DhR9nR1MvtJXyryuuzItFzuRZY_26bcl2m5_BXLnXFLdmVaLne18mfbkG2ZlstfsdwZ1-WeTMvlrsZsCCCAAAIIIIAAAggggAACCCCAAAIIIIAAAgggcBYCzg962-33QC9V86_p8mtXOW_sX3vrw9rnbtH1Z2y7jbbvUvO1O93BoNtp59VFl65qXKvd6fc77VZeXVVcRdft9vph2O918-qi81Q1rtlq93rtVjOvriquous2H5r4Hzbz6qLzVDWu0Wx1u61mI6-uKi7WRQABBBBAAAEEEEAAAQQQQAABBBBAAAEEEECgUoFbgZJPA1F_eUtm221VlHMsculd33dy4tLn2qLkmyIZo5vusN8b1kkV9Re4xvjGjX3zsxD3cEyCzKsLXHKlQ7Ljjvwrjavo4k_Hn0T9f_j82O9vIlyUz0nRz1M8Lroy-9-A-S6K0QgggAACCCCAAAIIIIAAAggggAACCCCAAAJnJXC8rdz3t0WJW3szXtP5-xt1ZXL56F6SGUkk75W88dHM5ru5niWflQ7rIIAAAggggAACCCCAAAIIIIAAAggggAACCCCAAAIIIFBMYLj7teq98Lr-hV98Uf-25ULdf9nL-_2J02zzPxUJZ_wUC726UeGMVF1kxVaeDL_YbzEKAQQQQAABBBBAAAEEEEAAAQQQQAABBBBAAAEEEEAgdwvtSSDur4H-HrfaxVf1oB8dpV67Lhe_c--c-G435bjeZM6aV_l6knFeOvFcpDl41BwcjspxK-49tP0Na_QPG_1wVI5bcW9oe_zt8Pt2-HhUjltx72Pb4w96YdDbH5XjVty7vxDxH0Txm3LcGj63Pf7Jv1_b452Mb697sNcdjMpxK-4dLNr1EC8CCCCAAAIIIIAAAggggAACCCCAAAIIIICAJQK3ApHbwbLIstyMQzLf7XblI7cRnXZLb7OVGPGi_1970b_8yfp9wRmfNXNEk4QAAggggAACCCCAAAIIIIAAAggggAACCCCAAAII2CTgrOvTbn8GJqSaOe32sSfOyoHfWnVfdNJxZp10i_qi5OjjbTp7ujqZ_Yk-X89br--YR1Rk1TYRZcWyuXnfPKIiq7Y9_q2tXfOIiqza9vg3NrbNIyqyatvjX1-_Zx5RkVXbHj_xIYAAAggggAACCCCAAAIIIIAAAggggAACCCCAQJZAoDt1_lbUjfhl9dtPcmHF_eTETSaT34632uKU1Zd-fXJcKoLdYTuv5u1CAAEEEEAAAQQQQAABBBBAAAEEEEAAAQQQQAABBBBAYFEEnC_1abc_AhPu4B1dHHnK_WBF3qu7jdq81zA8EWdOs81KzdSAvWG7retW1Dat0036ppqjlLTTfV-lXr89bK-l-tI3OUyupatf7yxI_HGccWoMa2N_-vLxYnn-SX-ef_JepD8_p_tJyZ49HX_WiFk3UZ31-mlf0zPH_-gw1F_BOLpXqWmnn592_MyPAAIIIIAAAggggAACCCCAAAIIIIAAAggggICNAs7Vnj6xpneRjn15Ow7Q_fmJnBdZG51kS8eddZJt7j4zofmP_bRsI1Y6psnYbY-3eHxh9L6QEEAAAQQQQAABBBBAAAEEEEAAAQQQQAABBBBAAAEE5hH4Dw
  //
  
    // Song data
    const song = {
      songData: [
        { // Instrument 0
          i: [
          2, // OSC1_WAVEFORM
          97, // OSC1_VOL
          128, // OSC1_SEMI
          0, // OSC1_XENV
          2, // OSC2_WAVEFORM
          99, // OSC2_VOL
          128, // OSC2_SEMI
          3, // OSC2_DETUNE
          1, // OSC2_XENV
          8, // NOISE_VOL
          0, // ENV_ATTACK
          113, // ENV_SUSTAIN
          0, // ENV_RELEASE
          5, // ARP_CHORD
          4, // ARP_SPEED
          0, // LFO_WAVEFORM
          195, // LFO_AMT
          6, // LFO_FREQ
          1, // LFO_FX_FREQ
          3, // FX_FILTER
          126, // FX_FREQ
          32, // FX_RESONANCE
          0, // FX_DIST
          17, // FX_DRIVE
          227, // FX_PAN_AMT
          8, // FX_PAN_FREQ
          139, // FX_DELAY_AMT
          7 // FX_DELAY_TIME
          ],
          // Patterns
          p: [1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,,,,,,,,,,,,,1,2,3,4,1,2,3,4,1,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,1,7],
          // Columns
          c: [
            {n: [144],
             f: []},
            {n: [142],
             f: []},
            {n: [147],
             f: []},
            {n: [140],
             f: []},
            {n: [],
             f: []},
            {n: [,,,,,,,,,,,,,,,,144],
             f: []},
            {n: [],
             f: []}
          ]
        },
        { // Instrument 1
          i: [
          2, // OSC1_WAVEFORM
          13, // OSC1_VOL
          128, // OSC1_SEMI
          0, // OSC1_XENV
          2, // OSC2_WAVEFORM
          72, // OSC2_VOL
          128, // OSC2_SEMI
          3, // OSC2_DETUNE
          1, // OSC2_XENV
          0, // NOISE_VOL
          0, // ENV_ATTACK
          40, // ENV_SUSTAIN
          0, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          195, // LFO_AMT
          6, // LFO_FREQ
          0, // LFO_FX_FREQ
          2, // FX_FILTER
          137, // FX_FREQ
          0, // FX_RESONANCE
          1, // FX_DIST
          31, // FX_DRIVE
          113, // FX_PAN_AMT
          6, // FX_PAN_FREQ
          71, // FX_DELAY_AMT
          6 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,1,1,1,1,1,2,2,1,1,2,2,1,4,2,1,1,4,2,1,1,4,2,1,1,4,2,1,1,4,2,1,1,4,2,5,1,4,2,1,1,4,2,1],
          // Columns
          c: [
            {n: [108,,120,,108,,120,,108,,120,,108,,120,,108,,120,,108,,120,,108,,120,,108,,120],
             f: []},
            {n: [106,,118,,106,,118,,106,,118,,106,,118,,106,,118,,106,,118,,106,,118,,106,,118],
             f: []},
            {n: [111,,123,,111,,123,,111,,123,,111,,123,,111,,123,,111,,123,,111,,123,,111,,123],
             f: []},
            {n: [104,,116,,104,,116,,104,,116,,104,,116,,104,,116,,104,,116,,104,,116,,104,,116],
             f: []},
            {n: [103,,115,,103,,115,,103,,115,,103,,115,,103,,115,,103,,115,,103,,115,,103,,115],
             f: []}
          ]
        },
        { // Instrument 2
          i: [
          2, // OSC1_WAVEFORM
          159, // OSC1_VOL
          128, // OSC1_SEMI
          0, // OSC1_XENV
          2, // OSC2_WAVEFORM
          200, // OSC2_VOL
          128, // OSC2_SEMI
          0, // OSC2_DETUNE
          0, // OSC2_XENV
          0, // NOISE_VOL
          6, // ENV_ATTACK
          5, // ENV_SUSTAIN
          43, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          105, // LFO_AMT
          3, // LFO_FREQ
          1, // LFO_FX_FREQ
          2, // FX_FILTER
          37, // FX_FREQ
          145, // FX_RESONANCE
          43, // FX_DIST
          47, // FX_DRIVE
          77, // FX_PAN_AMT
          6, // FX_PAN_FREQ
          92, // FX_DELAY_AMT
          3 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,1,1,2,2,1,1,2,2,1,4,2,1,1,4,2,1,1,4,2,1,1,4,2,1,1,4,2,1,1,4,2,6],
          // Columns
          c: [
            {n: [135,137,139,144,144,139,137,135,135,137,139,144,144,139,137,135,135,137,139,144,144,139,137,135,135,137,139,144,144,139,137,135],
             f: []},
            {n: [134,135,137,142,142,137,135,134,134,135,137,142,142,137,135,134,134,135,137,142,142,137,135,134,134,135,137,142,142,137,135,134],
             f: []},
            {n: [139,140,142,147,147,142,140,139,139,140,142,147,147,142,140,139,139,140,142,147,147,142,140,139,139,140,142,147,147,142,140,139],
             f: []},
            {n: [132,134,135,140,140,135,134,132,132,134,135,140,140,135,134,132,132,134,135,140,140,135,134,132,132,134,135,140,140,135,134,132],
             f: []},
            {n: [132,133,135,140,140,135,133,132,132,133,135,140,140,135,133,132,132,133,135,140,140,135,133,132,132,133,135,140,140,135,133,132],
             f: []},
            {n: [130,132,134,139,139,134,132,130,130,132,134,139,139,134,132,130,130,132,134,139,139,134,132,130,130,132,134,139,139,134,132,130],
             f: []}
          ]
        },
        { // Instrument 3
          i: [
          0, // OSC1_WAVEFORM
          91, // OSC1_VOL
          128, // OSC1_SEMI
          1, // OSC1_XENV
          0, // OSC2_WAVEFORM
          89, // OSC2_VOL
          128, // OSC2_SEMI
          0, // OSC2_DETUNE
          1, // OSC2_XENV
          210, // NOISE_VOL
          4, // ENV_ATTACK
          7, // ENV_SUSTAIN
          43, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          60, // LFO_AMT
          0, // LFO_FREQ
          1, // LFO_FX_FREQ
          2, // FX_FILTER
          255, // FX_FREQ
          0, // FX_RESONANCE
          0, // FX_DIST
          31, // FX_DRIVE
          61, // FX_PAN_AMT
          5, // FX_PAN_FREQ
          5, // FX_DELAY_AMT
          2 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,,,,,,,,,,,,,,,,1,2,2,2,2,2,2,2,5,2,2,2,2,,,,,,,,,2,2,2,3,2,2,2,2,2,2,2,4,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,3,2,2,2,2],
          // Columns
          c: [
            {n: [,,,,,,,,,,,,,,,,,,,,142,,,,,,142,,142,,142,142],
             f: []},
            {n: [,,,,142,,,,,,,,142,,,,,,,,142,,,,,,,,142],
             f: []},
            {n: [,,,,142,,,,,,,,142,,,,,,,,142,,,,,,142,,142,,142],
             f: []},
            {n: [,,,,142,,,,,,,,142,,,,,,142,,142,,,,,,142,,142,,142,142],
             f: []},
            {n: [,,,,142,,,,,,,,142,,,,,,,,142,,,,,,,,142,,142],
             f: []}
          ]
        },
        { // Instrument 4
          i: [
          0, // OSC1_WAVEFORM
          255, // OSC1_VOL
          116, // OSC1_SEMI
          1, // OSC1_XENV
          3, // OSC2_WAVEFORM
          67, // OSC2_VOL
          116, // OSC2_SEMI
          0, // OSC2_DETUNE
          1, // OSC2_XENV
          0, // NOISE_VOL
          3, // ENV_ATTACK
          6, // ENV_SUSTAIN
          45, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          0, // LFO_AMT
          0, // LFO_FREQ
          0, // LFO_FX_FREQ
          2, // FX_FILTER
          226, // FX_FREQ
          122, // FX_RESONANCE
          1, // FX_DIST
          36, // FX_DRIVE
          0, // FX_PAN_AMT
          0, // FX_PAN_FREQ
          0, // FX_DELAY_AMT
          0 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,,,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],
          // Columns
          c: [
            {n: [140,,,,140,,,,140,,,,140,,,,140,,,,140,,,,140,,,,140,,,,140,,,,140,,,,140,,,,140,,,,140,,,,140,,,,140,,,,140],
             f: []}
          ]
        },
        { // Instrument 5
          i: [
          0, // OSC1_WAVEFORM
          0, // OSC1_VOL
          140, // OSC1_SEMI
          0, // OSC1_XENV
          0, // OSC2_WAVEFORM
          0, // OSC2_VOL
          140, // OSC2_SEMI
          0, // OSC2_DETUNE
          0, // OSC2_XENV
          60, // NOISE_VOL
          4, // ENV_ATTACK
          10, // ENV_SUSTAIN
          34, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          187, // LFO_AMT
          5, // LFO_FREQ
          0, // LFO_FX_FREQ
          1, // FX_FILTER
          239, // FX_FREQ
          135, // FX_RESONANCE
          0, // FX_DIST
          20, // FX_DRIVE
          108, // FX_PAN_AMT
          5, // FX_PAN_FREQ
          16, // FX_DELAY_AMT
          4 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,,,,,,,,,,,,,,,,,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2],
          // Columns
          c: [
            {n: [147,,147,,147,,147,,147,,147,,147,,147,,147,,147,,147,,147,,147,,147,,147,,147],
             f: []},
            {n: [147,147,147,147,147,147,147,147,147,147,147,147,147,147,147,147,147,147,147,147,147,147,147,147,147,147,147,147,147,147,147,147],
             f: []}
          ]
        },
        { // Instrument 6
          i: [
          2, // OSC1_WAVEFORM
          192, // OSC1_VOL
          128, // OSC1_SEMI
          0, // OSC1_XENV
          3, // OSC2_WAVEFORM
          191, // OSC2_VOL
          128, // OSC2_SEMI
          3, // OSC2_DETUNE
          0, // OSC2_XENV
          0, // NOISE_VOL
          6, // ENV_ATTACK
          24, // ENV_SUSTAIN
          29, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          162, // LFO_AMT
          2, // LFO_FREQ
          1, // LFO_FX_FREQ
          1, // FX_FILTER
          33, // FX_FREQ
          56, // FX_RESONANCE
          0, // FX_DIST
          24, // FX_DRIVE
          143, // FX_PAN_AMT
          3, // FX_PAN_FREQ
          99, // FX_DELAY_AMT
          3 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,,,,,,,,,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,,,,,,,,,,,,,,,,,,,,,1,5,2,1,1,5,2,1,1,5,2,1,1,5,2,7,1,5,2,1,1,5,2,1,1,5,2,1,1,5,2,7,1],
          // Columns
          c: [
            {n: [132,144,151,132,144,149,132,144,151,132,144,149,132,144,151,149,132,144,151,132,144,149,132,144,151,132,144,149,132,144,151,149],
             f: []},
            {n: [130,142,149,130,142,147,130,142,149,130,142,147,130,142,149,147,130,142,149,130,142,147,130,142,149,130,142,147,130,142,149,147],
             f: []},
            {n: [135,147,154,135,147,152,135,147,154,135,147,152,135,147,154,152,135,147,154,135,147,152,135,147,154,135,147,152,135,147,154,152],
             f: []},
            {n: [128,140,147,128,140,145,128,140,147,128,140,145,128,140,147,145,128,140,147,128,140,145,128,140,147,128,140,145,128,140,147,145],
             f: []},
            {n: [128,140,147,128,140,146,128,140,147,128,140,146,128,140,147,146,128,140,147,128,140,146,128,140,147,128,140,146,128,140,147,146],
             f: []},
            {n: [132,144,151,132,144,149,132,144,151,132,144,149,132,144,151,149],
             f: []},
            {n: [127,139,146,127,139,144,127,139,146,127,139,144,127,139,146,144,127,139,146,127,139,144,127,139,146,127,139,144,127,139,146,144],
             f: []}
          ]
        },
        { // Instrument 7
          i: [
          0, // OSC1_WAVEFORM
          91, // OSC1_VOL
          128, // OSC1_SEMI
          0, // OSC1_XENV
          0, // OSC2_WAVEFORM
          95, // OSC2_VOL
          128, // OSC2_SEMI
          12, // OSC2_DETUNE
          0, // OSC2_XENV
          0, // NOISE_VOL
          12, // ENV_ATTACK
          0, // ENV_SUSTAIN
          72, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          0, // LFO_AMT
          0, // LFO_FREQ
          0, // LFO_FX_FREQ
          2, // FX_FILTER
          255, // FX_FREQ
          0, // FX_RESONANCE
          0, // FX_DIST
          36, // FX_DRIVE
          83, // FX_PAN_AMT
          3, // FX_PAN_FREQ
          130, // FX_DELAY_AMT
          4 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,1,2,3,4,1,2,3,4,1,2,3,4],
          // Columns
          c: [
            {n: [144],
             f: []},
            {n: [142],
             f: []},
            {n: [147],
             f: []},
            {n: [140],
             f: []}
          ]
        },
        { // Instrument 8
          i: [
          2, // OSC1_WAVEFORM
          103, // OSC1_VOL
          128, // OSC1_SEMI
          0, // OSC1_XENV
          3, // OSC2_WAVEFORM
          203, // OSC2_VOL
          128, // OSC2_SEMI
          0, // OSC2_DETUNE
          0, // OSC2_XENV
          0, // NOISE_VOL
          0, // ENV_ATTACK
          6, // ENV_SUSTAIN
          29, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          84, // LFO_AMT
          4, // LFO_FREQ
          0, // LFO_FX_FREQ
          2, // FX_FILTER
          39, // FX_FREQ
          146, // FX_RESONANCE
          5, // FX_DIST
          134, // FX_DRIVE
          60, // FX_PAN_AMT
          3, // FX_PAN_FREQ
          11, // FX_DELAY_AMT
          2 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,,,,,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,1,1,1,1,1,2,2,1,1,2,2,1,4,2,1,1,4,2,1,1,4,2,1,1,4,2,1,1,4,2,1,1,4,2,5,1,4,2,1,1,4,2,1,1,4,2,1,1,4,2,5],
          // Columns
          c: [
            {n: [108,108,120,108,108,120,108,120,108,108,120,108,108,120,108,120,108,108,120,108,108,120,108,120,108,108,120,108,108,120,108,120],
             f: []},
            {n: [106,106,118,106,106,118,106,118,106,106,118,106,106,118,106,118,106,106,118,106,106,118,106,118,106,106,118,106,106,118,106,118],
             f: []},
            {n: [111,111,123,111,111,123,111,123,111,111,123,111,111,123,111,123,111,111,123,111,111,123,111,123,111,111,123,111,111,123,111,123],
             f: []},
            {n: [104,104,116,104,104,116,104,116,104,104,116,104,104,116,104,116,104,104,116,104,104,116,104,116,104,104,116,104,104,116,104,116],
             f: []},
            {n: [103,103,115,103,103,115,103,115,103,103,115,103,103,115,103,115,103,103,115,103,103,115,103,115,103,103,115,103,103,115,103,115],
             f: []}
          ]
        },
        { // Instrument 9
          i: [
          0, // OSC1_WAVEFORM
          0, // OSC1_VOL
          128, // OSC1_SEMI
          0, // OSC1_XENV
          0, // OSC2_WAVEFORM
          0, // OSC2_VOL
          128, // OSC2_SEMI
          0, // OSC2_DETUNE
          0, // OSC2_XENV
          125, // NOISE_VOL
          0, // ENV_ATTACK
          1, // ENV_SUSTAIN
          59, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          0, // LFO_AMT
          0, // LFO_FREQ
          0, // LFO_FX_FREQ
          1, // FX_FILTER
          193, // FX_FREQ
          171, // FX_RESONANCE
          0, // FX_DIST
          20, // FX_DRIVE
          39, // FX_PAN_AMT
          3, // FX_PAN_FREQ
          88, // FX_DELAY_AMT
          3 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,,,,,,,,,,,,,,,,,1,1,1,1,1,1,1,1,1,1,1,1,,,,,,,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],
          // Columns
          c: [
            {n: [,,,,123,,,,,,,,123,,,,,,,,123,,,,,,,,123],
             f: []}
          ]
        },
        { // Instrument 10
          i: [
          2, // OSC1_WAVEFORM
          100, // OSC1_VOL
          128, // OSC1_SEMI
          0, // OSC1_XENV
          3, // OSC2_WAVEFORM
          201, // OSC2_VOL
          128, // OSC2_SEMI
          0, // OSC2_DETUNE
          0, // OSC2_XENV
          0, // NOISE_VOL
          0, // ENV_ATTACK
          144, // ENV_SUSTAIN
          58, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          195, // LFO_AMT
          4, // LFO_FREQ
          1, // LFO_FX_FREQ
          3, // FX_FILTER
          76, // FX_FREQ
          39, // FX_RESONANCE
          0, // FX_DIST
          63, // FX_DRIVE
          108, // FX_PAN_AMT
          3, // FX_PAN_FREQ
          130, // FX_DELAY_AMT
          6 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,1,2,3,4,1,2,3,5],
          // Columns
          c: [
            {n: [132,,,,,,,,,,,,127,,,,,,,,135,,,,134,,,,,,135],
             f: [12,,,,,,,,,,,,12,,,,,,,,12,,,,,,,,,,,,101,,,,,,,,,,,,95,,,,,,,,71]},
            {n: [140,,,,,,,,,,,,132,,,,,,,,139,,,,137,,,,,,135],
             f: [12,,,,,,,,,,,,12,,,,,,,,12,,,,,,,,,,,,101,,,,,,,,,,,,95,,,,,,,,71]},
            {n: [137,,,,,,,,,,,,130,,,,,,,,134,,,,135],
             f: [12,,,,,,,,,,,,12,,,,,,,,12,,,,12,,,,,,,,101,,,,,,,,,,,,95,,,,,,,,71,,,,95]},
            {n: [132],
             f: [12,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,144]},
            {n: [144],
             f: [12,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,144]}
          ]
        },
        { // Instrument 11
          i: [
          2, // OSC1_WAVEFORM
          40, // OSC1_VOL
          140, // OSC1_SEMI
          1, // OSC1_XENV
          0, // OSC2_WAVEFORM
          0, // OSC2_VOL
          140, // OSC2_SEMI
          0, // OSC2_DETUNE
          0, // OSC2_XENV
          255, // NOISE_VOL
          5, // ENV_ATTACK
          0, // ENV_SUSTAIN
          48, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          0, // LFO_AMT
          0, // LFO_FREQ
          0, // LFO_FX_FREQ
          3, // FX_FILTER
          186, // FX_FREQ
          192, // FX_RESONANCE
          0, // FX_DIST
          17, // FX_DRIVE
          0, // FX_PAN_AMT
          0, // FX_PAN_FREQ
          71, // FX_DELAY_AMT
          1 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,,,,,,,,,,,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],
          // Columns
          c: [
            {n: [,,147,,,,147,,,,147,,,,147,,,,147,,,,147,,,,147,,,,147],
             f: []}
          ]
        },
      ],
      rowLen: 5752,   // In sample lengths
      patternLen: 32,  // Rows per pattern
      endPattern: 90,  // End pattern
      numChannels: 12  // Number of channels
    };

  //
  // Data url for song2:
  // http://sb.bitsnbites.eu/?data=U0JveAwC7d09axRBGADgd3fvNjEEIxIhFsHTxso_4BeinbWIpYUg-EEEJQkEyRICURJCuCPYWdr4E2zUiBDstPY3-BPiXs5TSNhLF3bleW7efWdnp5g52GuGmXt9JuJcdE6kD4rIdouIaE93yutOnmSPb493fuRLE0matUbFenRjKzajKtfdevT2R1qV624z3sR2OdaqXP_xb-9_01UZAAAAAADguKUfizI2Tkc8XHj7p6kd0YmYGT9q7exhw-f-pOHjn2v4-B95_QAAAAAAgLr5WSTxvYhkr5VfL29vjCXZ3lScnY6ZvP84GaH_fLi7rCoDAAAAAABAY-y9SMqI5GQrvzRoSV9N9fed3UyGXarWzvqnAo4KAAAAAAAAaJL0SxHpbjFWVvPZ8rLcStLpdwvfevmdwb6zEWc2Li-v98t6Va773BcXV_tltSrXffxLS2v9slaV6z7--fmVflmpyt5OAAAAAADguGWfi0i_FnnE5OT58v5aK0mf3h3rPMtupcM-VWtnEc9jdNTd4hFRd3NHRN3NHxEAAAAAAADHbWMQV1sTF8rah3Ykv9ai86R9qjXsUXVm41yM_gAAAAAAAECzFIN4GcmVQUPy6X3MXszuZcMeVWtnzd_3BAAAAAAAAP-kD4rIdouy1r5_ubzu5Em6FtHp5d2xg33_nNXYHt4f_kOzrb-1bgPm3jtw3z00i3rbrGhvyvi7DX93tv18AAAAAADAf-c3
  //

    // Song2 data
    const song2 = {
      songData: [
        { // Instrument 0
          i: [
          2, // OSC1_WAVEFORM
          100, // OSC1_VOL
          128, // OSC1_SEMI
          0, // OSC1_XENV
          3, // OSC2_WAVEFORM
          201, // OSC2_VOL
          128, // OSC2_SEMI
          0, // OSC2_DETUNE
          0, // OSC2_XENV
          0, // NOISE_VOL
          5, // ENV_ATTACK
          20, // ENV_SUSTAIN
          32, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          195, // LFO_AMT
          6, // LFO_FREQ
          1, // LFO_FX_FREQ
          3, // FX_FILTER
          107, // FX_FREQ
          74, // FX_RESONANCE
          8, // FX_DIST
          32, // FX_DRIVE
          211, // FX_PAN_AMT
          6, // FX_PAN_FREQ
          123, // FX_DELAY_AMT
          10 // FX_DELAY_TIME
          ],
          // Patterns
          p: [1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4],
          // Columns
          c: [
            {n: [139,,146,,144,,142,,139,,146,,144,,142,,139,,146,,144,,142,,139,,146,,144,,142],
             f: []},
            {n: [139,,147,,146,,144,,139,,147,,146,,144,,139,,147,,146,,144,,139,,147,,146,,144],
             f: []},
            {n: [142,,151,,149,,147,,142,,151,,149,,147,,142,,151,,149,,147,,142,,151,,149,,147],
             f: []},
            {n: [142,,149,,147,,146,,142,,149,,147,,146,,142,,149,,147,,146,,142,,149,,147,,146],
             f: []}
          ]
        },
        { // Instrument 1
          i: [
          2, // OSC1_WAVEFORM
          192, // OSC1_VOL
          128, // OSC1_SEMI
          0, // OSC1_XENV
          2, // OSC2_WAVEFORM
          192, // OSC2_VOL
          140, // OSC2_SEMI
          18, // OSC2_DETUNE
          0, // OSC2_XENV
          0, // NOISE_VOL
          103, // ENV_ATTACK
          119, // ENV_SUSTAIN
          158, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          0, // LFO_AMT
          0, // LFO_FREQ
          0, // LFO_FX_FREQ
          2, // FX_FILTER
          5, // FX_FREQ
          0, // FX_RESONANCE
          0, // FX_DIST
          32, // FX_DRIVE
          0, // FX_PAN_AMT
          0, // FX_PAN_FREQ
          24, // FX_DELAY_AMT
          8 // FX_DELAY_TIME
          ],
          // Patterns
          p: [1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4],
          // Columns
          c: [
            {n: [103],
             f: []},
            {n: [108],
             f: []},
            {n: [111],
             f: []},
            {n: [106],
             f: []}
          ]
        },
        { // Instrument 2
          i: [
          0, // OSC1_WAVEFORM
          221, // OSC1_VOL
          128, // OSC1_SEMI
          1, // OSC1_XENV
          0, // OSC2_WAVEFORM
          210, // OSC2_VOL
          128, // OSC2_SEMI
          0, // OSC2_DETUNE
          1, // OSC2_XENV
          255, // NOISE_VOL
          4, // ENV_ATTACK
          6, // ENV_SUSTAIN
          62, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          64, // LFO_AMT
          7, // LFO_FREQ
          1, // LFO_FX_FREQ
          3, // FX_FILTER
          255, // FX_FREQ
          15, // FX_RESONANCE
          0, // FX_DIST
          25, // FX_DRIVE
          20, // FX_PAN_AMT
          0, // FX_PAN_FREQ
          24, // FX_DELAY_AMT
          6 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],
          // Columns
          c: [
            {n: [,,,,142,,,,,,,,142,,,,,,,,142,,,,,,,,142],
             f: []}
          ]
        },
        { // Instrument 3
          i: [
          0, // OSC1_WAVEFORM
          255, // OSC1_VOL
          116, // OSC1_SEMI
          1, // OSC1_XENV
          0, // OSC2_WAVEFORM
          255, // OSC2_VOL
          116, // OSC2_SEMI
          0, // OSC2_DETUNE
          1, // OSC2_XENV
          14, // NOISE_VOL
          4, // ENV_ATTACK
          6, // ENV_SUSTAIN
          45, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          0, // LFO_AMT
          0, // LFO_FREQ
          0, // LFO_FX_FREQ
          2, // FX_FILTER
          136, // FX_FREQ
          15, // FX_RESONANCE
          0, // FX_DIST
          32, // FX_DRIVE
          0, // FX_PAN_AMT
          0, // FX_PAN_FREQ
          66, // FX_DELAY_AMT
          1 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],
          // Columns
          c: [
            {n: [147,,,,147,,,,147,,,,147,,,,147,,,,147,,,,147,,,,147],
             f: []}
          ]
        },
        { // Instrument 4
          i: [
          2, // OSC1_WAVEFORM
          196, // OSC1_VOL
          128, // OSC1_SEMI
          0, // OSC1_XENV
          2, // OSC2_WAVEFORM
          201, // OSC2_VOL
          128, // OSC2_SEMI
          7, // OSC2_DETUNE
          0, // OSC2_XENV
          0, // NOISE_VOL
          0, // ENV_ATTACK
          6, // ENV_SUSTAIN
          29, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          127, // LFO_AMT
          4, // LFO_FREQ
          1, // LFO_FX_FREQ
          2, // FX_FILTER
          20, // FX_FREQ
          166, // FX_RESONANCE
          119, // FX_DIST
          203, // FX_DRIVE
          147, // FX_PAN_AMT
          6, // FX_PAN_FREQ
          84, // FX_DELAY_AMT
          6 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4],
          // Columns
          c: [
            {n: [127,127,139,127,127,139,127,139,127,127,139,127,127,139,127,139,127,127,139,127,127,139,127,139,127,127,139,127,127,139,127,139],
             f: []},
            {n: [120,120,132,120,120,132,120,132,120,120,132,120,120,132,120,132,120,120,132,120,120,132,120,132,120,120,132,120,120,132,120,132],
             f: []},
            {n: [123,123,135,123,123,135,123,135,123,123,135,123,123,135,123,135,123,123,135,123,123,135,123,135,123,123,135,123,123,135,123,135],
             f: []},
            {n: [118,118,130,118,118,130,118,130,118,118,130,118,118,130,118,130,118,118,130,118,118,130,118,130,118,118,130,118,118,130,118,130],
             f: []}
          ]
        },
        { // Instrument 5
          i: [
          3, // OSC1_WAVEFORM
          194, // OSC1_VOL
          128, // OSC1_SEMI
          0, // OSC1_XENV
          2, // OSC2_WAVEFORM
          198, // OSC2_VOL
          128, // OSC2_SEMI
          6, // OSC2_DETUNE
          0, // OSC2_XENV
          0, // NOISE_VOL
          12, // ENV_ATTACK
          12, // ENV_SUSTAIN
          33, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          61, // LFO_AMT
          4, // LFO_FREQ
          1, // LFO_FX_FREQ
          2, // FX_FILTER
          109, // FX_FREQ
          86, // FX_RESONANCE
          7, // FX_DIST
          32, // FX_DRIVE
          112, // FX_PAN_AMT
          3, // FX_PAN_FREQ
          67, // FX_DELAY_AMT
          2 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4],
          // Columns
          c: [
            {n: [,,115,,,,115,,,,115,,,,115,,,,115,,,,115,,,,115,,,,115],
             f: []},
            {n: [,,120,,,,120,,,,120,,,,120,,,,120,,,,120,,,,120,,,,120],
             f: []},
            {n: [,,111,,,,111,,,,111,,,,111,,,,111,,,,111,,,,111,,,,111],
             f: []},
            {n: [,,118,,,,118,,,,118,,,,118,,,,118,,,,118,,,,118,,,,118],
             f: []}
          ]
        },
        { // Instrument 6
          i: [
          0, // OSC1_WAVEFORM
          0, // OSC1_VOL
          140, // OSC1_SEMI
          0, // OSC1_XENV
          0, // OSC2_WAVEFORM
          0, // OSC2_VOL
          140, // OSC2_SEMI
          0, // OSC2_DETUNE
          0, // OSC2_XENV
          60, // NOISE_VOL
          4, // ENV_ATTACK
          10, // ENV_SUSTAIN
          34, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          187, // LFO_AMT
          5, // LFO_FREQ
          0, // LFO_FX_FREQ
          1, // FX_FILTER
          239, // FX_FREQ
          135, // FX_RESONANCE
          0, // FX_DIST
          32, // FX_DRIVE
          108, // FX_PAN_AMT
          5, // FX_PAN_FREQ
          16, // FX_DELAY_AMT
          4 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],
          // Columns
          c: [
            {n: [111,,111,,111,,111,,111,,111,,111,,111,,111,,111,,111,,111,,111,,111,,111,,111],
             f: []}
          ]
        },
        { // Instrument 7
          i: [
          0, // OSC1_WAVEFORM
          0, // OSC1_VOL
          128, // OSC1_SEMI
          0, // OSC1_XENV
          0, // OSC2_WAVEFORM
          0, // OSC2_VOL
          128, // OSC2_SEMI
          0, // OSC2_DETUNE
          0, // OSC2_XENV
          125, // NOISE_VOL
          0, // ENV_ATTACK
          1, // ENV_SUSTAIN
          59, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          0, // LFO_AMT
          0, // LFO_FREQ
          0, // LFO_FX_FREQ
          1, // FX_FILTER
          193, // FX_FREQ
          171, // FX_RESONANCE
          0, // FX_DIST
          29, // FX_DRIVE
          39, // FX_PAN_AMT
          3, // FX_PAN_FREQ
          88, // FX_DELAY_AMT
          3 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],
          // Columns
          c: [
            {n: [,,111,,,,111,,,,111,,,,111,,,,111,,,,111,,,,111,,,,111],
             f: []}
          ]
        },
        { // Instrument 8
          i: [
          2, // OSC1_WAVEFORM
          100, // OSC1_VOL
          128, // OSC1_SEMI
          0, // OSC1_XENV
          3, // OSC2_WAVEFORM
          201, // OSC2_VOL
          128, // OSC2_SEMI
          0, // OSC2_DETUNE
          0, // OSC2_XENV
          0, // NOISE_VOL
          5, // ENV_ATTACK
          96, // ENV_SUSTAIN
          58, // ENV_RELEASE
          0, // ARP_CHORD
          0, // ARP_SPEED
          0, // LFO_WAVEFORM
          195, // LFO_AMT
          6, // LFO_FREQ
          1, // LFO_FX_FREQ
          2, // FX_FILTER
          135, // FX_FREQ
          0, // FX_RESONANCE
          0, // FX_DIST
          32, // FX_DRIVE
          147, // FX_PAN_AMT
          6, // FX_PAN_FREQ
          146, // FX_DELAY_AMT
          7 // FX_DELAY_TIME
          ],
          // Patterns
          p: [,,,,,,,,,,,,,,,,1,2,3,4,1,2,3,5],
          // Columns
          c: [
            {n: [139,,,,,,,,,,,,,,,,,,144,,,,,,,,,,146],
             f: []},
            {n: [147,,,,,,,,,,,,,,,,146,,,,,,,,144],
             f: []},
            {n: [142,,,,,,,,,,,,,,,,,,,,,,,,144],
             f: []},
            {n: [146],
             f: []},
            {n: [149],
             f: []}
          ]
        },
      ],
      rowLen: 5513,   // In sample lengths
      patternLen: 32,  // Rows per pattern
      endPattern: 31,  // End pattern
      numChannels: 9  // Number of channels
    };

  //----------------------------------------------------------------------------
  // Demo program section
  //----------------------------------------------------------------------------

  // Initialize music generation (player).
      const t0 = new Date();
      AudioLib.player.init(song);

  // Generate music...
      let done = false;
      setInterval(() => {
        if (done) {
          AudioLib.done = true;
          return;
        }

    // var s = document.getElementById("status");
    // s.textContent = s.textContent + ".";

        done = AudioLib.player.generate() >= 1;

        if (done) {
          const t1 = new Date();
      // s.textContent = s.textContent + "done (" + (t1 - t0) + "ms)";

      // Put the generated song in an Audio element.
          const wave = AudioLib.player.createWave();

          AudioLib.audio.src = URL.createObjectURL(new Blob([wave], { type: 'audio/wav' }));
      // audio.play();
          AudioLib.audioDone();

/*
      // Start an oscilloscope animation.
      var ctx = document.getElementById("canvas").getContext("2d");
      setInterval(function () {
        // Get currently playing data.
        var t = audio.currentTime;
        var data = player.getData(t, 300);

        // Clear background.
        ctx.fillStyle = "rgb(0,30,0)";
        ctx.fillRect(0, 0, 300, 200);
        ctx.fillStyle = "rgb(0,30,60)";
        ctx.fillRect(0, 0, 300 * (t / audio.duration), 200);

        ctx.strokeStyle = "rgb(255,255,255)";

        // Plot left channel.
        ctx.beginPath();
        ctx.moveTo(0, 50 + 90 * data[0]);
        for (var k = 1; k < 300; ++k) {
          ctx.lineTo(k, 50 + 90 * data[k * 2]);
        }
        ctx.stroke();

        // Plot right channel.
        ctx.beginPath();
        ctx.moveTo(0, 150 + 90 * data[1]);
        for (var k = 1; k < 300; ++k) {
          ctx.lineTo(k, 150 + 90 * data[k * 2 + 1]);
        }
        ctx.stroke();
      }, 16);
      */
        }
      }, 0);
    };

    return AudioLib;
  }
// define globally if it doesn't already exist
  if (typeof (AudioLib) === 'undefined') {
    const mwindow = window;
    mwindow.AudioLib = defineLibrary();
  }
}(window)); // eslint-disable-line no-undef
