(function capsule(window) {
  function defineLibrary() {
    const Demo = {};
    let aspectRatio = 1;  // eslint-disable-line no-unused-vars
    let gl;
    let sceneFrame; // eslint-disable-line no-unused-vars
    let canvas;
    const demofb = {};

    let matrixFilter;
    let mixerFilter;
    let outputFilter;
    let puzzleFilter;
    let mandelbrot;
    // let tree;
    let scene;
    let slug;
    let time = 0.0;
    let source;
    let audioContext;
    let analyser;
    let lowpassDataArray;
    let started = false;
    let stage = 0;
    const fc = {
      framecount: 0,
      fps: 0.0,
      lastTime: performance.now(), // eslint-disable-line no-undef
      fpsElem: document.getElementById('fps'), // eslint-disable-line no-undef
      fpsUpdate() {
        fc.framecount++;
        if (fc.framecount > 100) {
          fc.framecount = 0;
          const now = performance.now(); // eslint-disable-line no-undef
          fc.fps = 1000.0 * (100.0 / (now - fc.lastTime));
          fc.lastTime = now;
          fc.fpsElem.innerHTML = `fps ${fc.fps.toFixed(2)}`;
        }
      }
    };

    function refresh() {
/*
      time = (performance.now() - timeStart) / 1000;
      if (time > 60) {
        timeStart = performance.now();
      }*/
      time = AudioLib.audio.currentTime;
      // const data = AudioLib.player.getData(time, 300);
      analyser.getFloatFrequencyData(lowpassDataArray);
      const data = lowpassDataArray;
      const dataIndexBasso = Math.floor((2.0 * 25.0 / 22050) * data.length);
      const dataIndexMedium = Math.floor((2.0 * 280.0 / 22050) * data.length);
      const dataIndexHigh = Math.floor((2.0 * 1500.0 / 22050) * data.length);
      // console.log([dataIndexBasso, dataIndexMedium, dataIndexHigh]);
      const dataLow = Math.pow(10.0, data[dataIndexBasso] / 20.0) * 2.0;
      const dataMedium = Math.pow(10.0, data[dataIndexMedium] / 20.0) * 100.0;
      const dataHigh = Math.pow(10.0, data[dataIndexHigh] / 20.0) * 100.0;
      // Do some drawing
      // console.log(data);
      // console.log(Math.pow(10.0, data[dataIndex] / 20.0) * 20.0);
      if (time > 12) {
        ButterflyShowLib.scrollSpeed = (Math.pow(10.0, data[dataIndexBasso] / 20.0)) * 2.0 + 0.001;
        ButterflyShowLib.colorAdd = [Math.min(1.0, dataLow), Math.min(1.0, dataHigh), Math.min(1.0, dataMedium)];
      } else {
        ButterflyShowLib.scrollSpeed = 0.0;
      }
      // console.log(ButterflyShowLib.colorAdd);
      if (time < 10 && time > 0) {
/*        ButterflyShowLib.rotateSpeed = 0.0;
        ButterflyShowLib.spread = 0;
        ButterflyShowLib.draw(gl, canvas);
*/
        // grayFilter.setT((Math.sin(time) + 1) / 2);
        // pencilFilter.draw(gl, canvas, demofb);
        puzzleFilter.setT((Math.cos(Math.PI + time / 10 * Math.PI) + 1) / 2);
        puzzleFilter.draw(gl, canvas, demofb);
        outputFilter.draw(gl, canvas, puzzleFilter.fb);
      } else if (time < 12) {
        gl.bindFramebuffer(gl.FRAMEBUFFER, demofb.frameBuffer);
        /*
        ButterflyShowLib.rotateSpeed = 0.0;
        ButterflyShowLib.draw(gl, canvas);
        */
        // grayFilter.setT((Math.sin(time) + 1) / 2);
        // pencilFilter.draw(gl, canvas, demofb);
        puzzleFilter.setT(1.0);
        puzzleFilter.draw(gl, canvas, demofb);
        mixerFilter.setT((Math.cos(Math.PI + (time - 10) / 2 * Math.PI) + 1) / 2);
        mixerFilter.draw(gl, canvas, puzzleFilter.fb, demofb);
        outputFilter.draw(gl, canvas, mixerFilter.fb);
      } else if (time < 24) {
        gl.bindFramebuffer(gl.FRAMEBUFFER, demofb.frameBuffer);
        /*
        ButterflyShowLib.rotateSpeed = 0.0;
        ButterflyShowLib.draw(gl, canvas);
        // pencilFilter.draw(gl, canvas, demofb);
        */
        /*
        mixerFilter.setT(1 - (Math.cos(Math.PI + (time - 12) / 10 * Math.PI) + 1) / 2);
        mixerFilter.draw(gl, canvas, demofb, demofb);*/
        outputFilter.draw(gl, canvas, demofb);
      }/* else if (time < 17) {
        gl.bindFramebuffer(gl.FRAMEBUFFER, demofb.frameBuffer);
        ButterflyShowLib.draw(gl, canvas);
        // ButterflyShowLib.scrollSpeed = 0.002;
        outputFilter.draw(gl, canvas, demofb);
      } else if (time < 20) {
        gl.bindFramebuffer(gl.FRAMEBUFFER, demofb.frameBuffer);
        ButterflyShowLib.draw(gl, canvas);
        ButterflyShowLib.spreadSpeed = 0.05 * (1 - ((Math.cos((time - 17) / 5 * Math.PI) + 1) / 2));
        outputFilter.draw(gl, canvas, demofb);
      }*/ else if (time < 180) {
        if (time > 20) {
          scene.cameraStyle = 'followPath';
        } else {
          scene.cameraStyle = undefined;
        }
        gl.bindFramebuffer(gl.FRAMEBUFFER, demofb.frameBuffer);
        scene.tick(gl, canvas, time - 20);
        scene.draw(gl, canvas);
        scene.setSpeed(Math.pow(10.0, data[dataIndexBasso] / 20.0) * 2.0 + 0.001);
        scene.setColorAdd([Math.min(1.0, dataLow), Math.min(1.0, dataHigh), Math.min(1.0, dataMedium)]);
        // tree.setT(time);
        // tree.draw(gl, canvas);
        outputFilter.draw(gl, canvas, demofb);
      } else if (time < 200) {
        gl.bindFramebuffer(gl.FRAMEBUFFER, demofb.frameBuffer);
        slug.setT(time);
        slug.setRGB([Math.min(1.0, dataLow), Math.min(1.0, dataHigh), Math.min(1.0, dataMedium)]);
        slug.draw(gl, canvas);
        outputFilter.draw(gl, canvas, demofb);
      } else if (time < 300) {
        gl.bindFramebuffer(gl.FRAMEBUFFER, demofb.frameBuffer);
        mandelbrot.tick(gl, canvas, time);
        mandelbrot.setRGB([Math.min(1.0, dataLow), Math.min(1.0, dataHigh), Math.min(1.0, dataMedium)]);
        mandelbrot.draw(gl, canvas);
        outputFilter.draw(gl, canvas, demofb);
      } else if (time < 317) {
        gl.bindFramebuffer(gl.FRAMEBUFFER, demofb.frameBuffer);
        ButterflyShowLib.spreadSpeed = 0.05;
        ButterflyShowLib.draw(gl, canvas);
        outputFilter.draw(gl, canvas, demofb);
      } else if (time < 327) {
        gl.bindFramebuffer(gl.FRAMEBUFFER, demofb.frameBuffer);
        ButterflyShowLib.spreadSpeed = 0.05;
        ButterflyShowLib.draw(gl, canvas);
        matrixFilter.setColor0([Math.min(1.0, dataHigh), Math.min(1.0, dataMedium), Math.min(1.0, dataLow), 1.0]);
        matrixFilter.setT((1 - ((Math.cos((time - 327) / 23 * Math.PI) + 1) / 2)));
        matrixFilter.setTime(time);
        matrixFilter.draw(gl, canvas, demofb);
        mixerFilter.setT((Math.cos(Math.PI + (time - 327) / 5 * Math.PI) + 1) / 2);
        mixerFilter.draw(gl, canvas, demofb, matrixFilter.fb);
        outputFilter.draw(gl, canvas, mixerFilter.fb);
      } else {
        gl.bindFramebuffer(gl.FRAMEBUFFER, demofb.frameBuffer);
        ButterflyShowLib.spreadSpeed = 0.05;
        ButterflyShowLib.draw(gl, canvas);
        matrixFilter.setColor0([Math.min(1.0, dataHigh), Math.min(1.0, dataMedium), Math.min(1.0, dataLow), 1.0]);
        matrixFilter.setT((1 - ((Math.cos((time - 327) / 23 * Math.PI) + 1) / 2)));
        matrixFilter.setTime(time);
        matrixFilter.draw(gl, canvas, demofb);
        outputFilter.draw(gl, canvas, matrixFilter.fb);
      }
      gl.finish();
    }

    function runner() {
      refresh();
      fc.fpsUpdate();
      sceneFrame = window // eslint-disable-line no-undef
      .requestAnimationFrame(runner);
      time = AudioLib.audio.currentTime;
      if (time >= 22 && time < 100) {
        scene.runPhysics(time);
      }
    }

    function startRunner() {
      gl.bindFramebuffer(gl.FRAMEBUFFER, demofb.frameBuffer);
      scene.draw(gl, canvas);
      runner();
    }

    function initWebGL(canvas) {
      const gl = canvas.getContext('webgl2') || canvas.getContext('experimental-webgl');
      gl.viewport(0, 0, canvas.width, canvas.height);
      return gl;
    }

    Demo.resize = function resize() {
      // const minDimension = Math.min(window.innerWidth, window.innerHeight);
      canvas.width = window.innerWidth;
      canvas.height = window.innerHeight;
      aspectRatio = canvas.width / canvas.height;

      FrameBufferLib.texturecounter = 0;
      demofb.texture = gl.createTexture();
      demofb.textureUnit = FrameBufferLib.getNextTextureUnit();
      demofb.frameBuffer = FrameBufferLib.createFramebuffer(gl, demofb.texture, canvas);
      if (matrixFilter) {
        matrixFilter.resize(gl, canvas);
        outputFilter.resize(gl, canvas);
        mixerFilter.resize(gl, canvas);
        puzzleFilter.resize(gl, canvas);
        mandelbrot.resize(gl, canvas);
        // grayFilter.resize(gl, canvas);
        // pencilFilter.resize(gl, canvas);
        ButterflyShowLib.resize(gl, canvas);
      }
    };

    function audioDone() {
      audioContext = new (window.AudioContext || window.webkitAudioContext)();
      source = audioContext.createMediaElementSource(AudioLib.audio);
      // Create the filter.
      // filter = audioContext.createBiquadFilter();
      analyser = audioContext.createAnalyser();
      analyser.fftSize = 2048;
      const bufferLength = analyser.frequencyBinCount;
      lowpassDataArray = new Float32Array(bufferLength);

      // filter.type = 'lowpass';
      // filter.frequency.value = 500;
      // Connect source to filter, filter to destination.
      source.connect(analyser);
      // filter.connect(analyser);
      source.connect(audioContext.destination);
      // Play!
      // source.start(0);
      // source.play();
      AudioLib.audio.play();
      // AudioLib.audio.currentTime = 120; // jump to seconds at start
      // AudioLib.audio.loop = true;
      AudioLib.audio.controls = 'controls';
      AudioLib.audio.style.width = '800px';

      document.getElementById('textlayer').appendChild(AudioLib.audio);

      startRunner();
    }

    function loadElements(step) {
      stage += step;
      const textElem = document.getElementById('somelayer');
      const result = { callback: null };
      switch (stage) {
        case 0:
          textElem.innerHTML += '<p>Creating Butterflies</p>';
          break;
        case 1:
          ButterflyShowLib.init(gl, canvas);
          break;
        case 2:
          textElem.innerHTML += '<p>Creating Spectacular End</p>';
          break;
        case 3:
          matrixFilter = new MatrixLib.Matrix(gl, canvas);
          break;
        case 4:
          textElem.innerHTML += '<p>Mixing</p>';
          break;
        case 5:
          mixerFilter = new MixerLib.Mixer(gl, canvas);
          break;
        case 6:
          textElem.innerHTML += '<p>Filtering</p>';
          break;
        case 7:
          outputFilter = new FilterLib.OutputFilter(gl, canvas);
          break;
        case 8:
          textElem.innerHTML += '<p>Gathering Pieces</p>';
          break;
        case 9:
          puzzleFilter = new Puzzle.PuzzleFilter(gl, canvas);
          break;
        case 10:
          textElem.innerHTML += '<p>Creating Fractal</p>';
          break;
        case 11:
          mandelbrot = new MandelbrotLib.Mandelbrot(gl, canvas);
          mandelbrot.init(gl, canvas);
          break;
        case 12:
          textElem.innerHTML += '<p>Creating Scene</p>';
          break;
        case 13:
          scene = new SceneLib.Scene(gl, canvas);
          break;
        case 14:
          textElem.innerHTML += '<p>Initiating Scene</p>';
          break;
        case 15:
          return scene.init(gl, canvas, textElem, () => setTimeout(() => loadElements(1), 10));
        case 16:
          textElem.innerHTML += '<p>Creating Gastropods</p>';
          break;
        case 17:
          slug = new GastropodaLib.Gastropoda(gl, canvas);
          break;
        case 18:
          textElem.innerHTML += '<p>Setting Data</p>';
          break;
        case 19:
          const d = DataLib.data[3];
          ButterflyShowLib.setData(d);
          break;
        case 20:
          textElem.innerHTML += '<p>Setting Callbacks</p>';
          break;
        case 21:
          AudioLib.setCallBack(audioDone);
          break;
        case 22:
          textElem.innerHTML += '<p>Generating Audio</p>';
          break;
        case 23:
          AudioLib.startDemo();
          break;
        case 24:
          textElem.innerHTML += '<p>And We Are Done! Something Still Takes Few More Seconds</p>';
          break;
        case 25:
          return;
      }
      /*
      if (result.callback !== null) {
        setTimeout(() => {
          result.callback(gl, canvas, textElem, (stage) => { this.loadElement(stage); });
        }, 10);
      } */
      setTimeout(() => { loadElements(1); }, 10);
    }

    function startDemo() {
      if (!started) {
        const textElem = document.getElementById('somelayer');
        textElem.innerHTML += '<p>PLAY</p>';
        setTimeout(() => { loadElements(0); }, 0);
        started = true;
      }
    }

    function touchDown() {
      if (!document.webkitFullscreenElement) {
        canvas.requestFullscreen();
      } else if (document.exitFullscreen) {
        // document.exitFullscreen();
      }
      startDemo();
    }

    function keydown(event) {
      switch (event.key) {
        case 'f':
          if (!document.webkitFullscreenElement) {
            canvas.requestFullscreen();
          } else if (document.exitFullscreen) {
            document.exitFullscreen();
          }
          break;
        case 'MediaPlayPause':
        case 'Enter':
          startDemo();
          break;
        default:
          console.log(event.key);
          break;
      }
    }


    Demo.start = function start() {
      canvas = document.getElementById('glcanvas'); // eslint-disable-line no-undef
      gl = initWebGL(canvas);
      const ext = gl.getExtension('EXT_color_buffer_float');
      if (!ext) {
        alert('need EXT_color_buffer_float');
        return;
      }
      FrameBufferLib.init(gl);
      Demo.resize();


      if (gl) {
        document.addEventListener('keydown', keydown);
        document.body.addEventListener('touchstart', (e) => { // eslint-disable-line no-undef
          if (e.target === canvas) {
            e.preventDefault();
          }
        }, false);
        canvas.addEventListener('touchstart', touchDown, false);
        canvas.style.cursor = 'none';
      }
    };

    return Demo;
  }
// define globally if it doesn't already exist
  if (typeof (Demo) === 'undefined') {
    const mwindow = window;
    mwindow.Demo = defineLibrary();
  }
}(window)); // eslint-disable-line no-undef
