(function capsule(window) {
  function defineLibrary() {
    const GrayLib = {};
    class Gray extends FilterLib.Filter {
      getFragmentShader() {
        this.fragmentShader = `precision highp float;
uniform sampler2D uTexture0;
varying highp vec2 v_texCoordinate;
void main() {
  vec4 c =  texture2D(uTexture0,v_texCoordinate);
  float gray = c.r*0.2126+c.g*0.7152+c.b*0.0722;
  gl_FragColor = vec4(gray,gray,gray,1.0);
}`;
      }

      constructor(gl, canvas) {
        super(gl, canvas);
      }

    }
    GrayLib.Gray = Gray;
    return GrayLib;
  }
// define globally if it doesn't already exist
  if (typeof (GrayLib) === 'undefined') {
    const mwindow = window;
    mwindow.GrayLib = defineLibrary();
  }
}(window)); // eslint-disable-line no-undef
